//
// Copyright © 2022 Nevis Security AG. All rights reserved.
//

import Flutter
import NevisMobileAuthentication

struct DeregistrationMethodHandler: MethodHandler {
	func execute(using client: MobileAuthenticationClient, with message: ChannelInMessage, result: @escaping FlutterResult) throws {
		let message: DeregistrationMessage = try validate(message: message)
		let operation = DeregistrationOperation(operationId: message.operationId)
		OperationCache.shared.put(operation, using: message.operationId)
		let deregistration = client.operations.deregistration
			.username(message.username)
			.onSuccess(operation.onSuccess)
			.onError(operation.onError)

		if let aaid = message.aaid {
			deregistration.aaid(aaid)
		}
		
		if let typedAuthorizationProvider = message.authorizationProvider {
			deregistration.authorizationProvider(typedAuthorizationProvider.wrapped)
		}

		deregistration.execute()
		result(EmptyResultMessage())
	}
}
