//
// Copyright © 2022 Nevis Security AG. All rights reserved.
//

import Flutter
import NevisMobileAuthentication

struct LocalDeleteAuthenticatorMethodHandler: MethodHandler {
	func execute(using client: MobileAuthenticationClient, with message: ChannelInMessage, result: @escaping FlutterResult) throws {
		let message: LocalDeleteAuthenticatorMessage = try validate(message: message)
		try client.localData.deleteAuthenticator(username: message.username,
		                                         aaid: message.aaid)
		result(EmptyResultMessage())
	}
}
