//
// Copyright © 2022 Nevis Security AG. All rights reserved.
//

import Flutter
import NevisMobileAuthentication

struct OutOfBandAuthenticationMethodHandler: MethodHandler {
	func execute(using _: MobileAuthenticationClient, with message: ChannelInMessage, result: @escaping FlutterResult) throws {
		let message: OutOfBandAuthenticationMessage = try validate(message: message)
		let operation: OutOfBandAuthenticationOperation = try OperationCache.shared.read(by: message.operationId)

		operation.authentication
			.accountSelector(operation.accountSelector)
			.authenticatorSelector(operation.authenticatorSelector)
			.biometricUserVerifier(operation.biometricUserVerifier)
			.pinUserVerifier(operation.pinUserVerifier)
			.onSuccess(operation.onSuccess)
			.onError(operation.onError)
			.execute()
		OperationCache.shared.put(operation, using: message.operationId)
		result(EmptyResultMessage())
	}
}
