//
// Copyright © 2022 Nevis Security AG. All rights reserved.
//

import Flutter
import NevisMobileAuthentication

struct PinChangeMethodHandler: MethodHandler {
	func execute(using client: MobileAuthenticationClient, with message: ChannelInMessage, result: @escaping FlutterResult) throws {
		let message: PinChangeMessage = try validate(message: message)
		let operation = PinChangeOperation(operationId: message.operationId,
		                                   pinPolicy: message.pinPolicy)
		OperationCache.shared.put(operation, using: message.operationId)
		client.operations.pinChange
			.username(message.username)
			.pinChanger(operation.pinChanger)
			.onSuccess(operation.onSuccess)
			.onError(operation.onError)
			.execute()
		result(EmptyResultMessage())
	}
}
