//
// Copyright © 2022 Nevis Security AG. All rights reserved.
//

import NevisMobileAuthentication

class AuthCloudApiRegistrationMessage: ChannelInMessage {
	// MARK: Properties

	let enrollResponse: String?
	let appLinkUri: String?
	var deviceInformation: DeviceInformation?
	var pinPolicy: PinPolicy?
	var allowDevicePasscodeAsFallback: Bool?

	// MARK: Decodable

	enum CodingKeys: String, CodingKey {
		case enrollResponse
		case appLinkUri
		case deviceInformation
		case pinPolicy
		case allowDevicePasscodeAsFallback
	}

	required init(from decoder: Decoder) throws {
		let container = try decoder.container(keyedBy: CodingKeys.self)
		self.enrollResponse = try container.decodeIfPresent(String.self, forKey: .enrollResponse)
		self.appLinkUri = try container.decodeIfPresent(String.self, forKey: .appLinkUri)
		self.deviceInformation = try container.decodeIfPresent(DeviceInformation.self, forKey: .deviceInformation)
		self.pinPolicy = try container.decodeIfPresent(PinPolicy.self, forKey: .pinPolicy)
		self.allowDevicePasscodeAsFallback = try container.decodeIfPresent(Bool.self, forKey: .allowDevicePasscodeAsFallback)
		try super.init(from: decoder)
	}
}
