//
// Copyright © 2022 Nevis Security AG. All rights reserved.
//

import NevisMobileAuthentication

class OutOfBandOperationMessage: ChannelInMessage {
	// MARK: Properties

	let payload: OutOfBandPayload
	let subOperationId: String

	enum CodingKeys: String, CodingKey {
		case payload
		case subOperationId
	}

	required init(from decoder: Decoder) throws {
		let container = try decoder.container(keyedBy: CodingKeys.self)
		self.payload = try container.decode(OutOfBandPayload.self, forKey: .payload)
		self.subOperationId = try container.decode(String.self, forKey: .subOperationId)
		try super.init(from: decoder)
	}
}
