//
// Copyright © 2022 Nevis Security AG. All rights reserved.
//

import NevisMobileAuthentication

class PinChangeMessage: ChannelInMessage {
	// MARK: Properties

	let username: String
	var pinPolicy: PinPolicy?

	// MARK: Decodable

	enum CodingKeys: String, CodingKey {
		case username
		case pinPolicy
	}

	required init(from decoder: Decoder) throws {
		let container = try decoder.container(keyedBy: CodingKeys.self)
		self.username = try container.decode(String.self, forKey: .username)
		self.pinPolicy = try container.decodeIfPresent(PinPolicy.self, forKey: .pinPolicy)
		try super.init(from: decoder)
	}
}
