// Copyright © 2022 Nevis Security AG. All rights reserved.

class AuthorizationProviderTestData {
  static const cookieName = 'cookie';
  static const cookieValue = 'cookie_value';
  static const cookieDomain = 'domain';
  static const cookieString = '$cookieName=$cookieValue;domain=$cookieDomain';
  static final uri = Uri.parse('https://example.com');
  static const jwt = 'jwt';

  static final cookieMap = {
    'uri': uri.toString(),
    'properties': cookieString,
  };

  static final cookieAuthorizationProviderMap = {
    'cookies': [cookieMap]
  };

  static final jwtAuthorizationProviderMap = {
    'jwt': jwt,
  };

  static final cookieSessionProviderMap = {
    'cookies': [cookieMap]
  };

  static final jwtSessionProviderMap = {
    'jwt': jwt,
  };

  static final sessionProviderAsCookieMap = {
    'type': 'CookieSessionProvider',
    'data': cookieAuthorizationProviderMap,
  };

  static final sessionProviderAsJwtMap = {
    'type': 'JwtSessionProvider',
    'data': jwtSessionProviderMap,
  };
}
